diff --git a/sys/net/bridge/if_bridge.c b/sys/net/bridge/if_bridge.c
index b677715..6cd2fa1 100644
--- a/sys/net/bridge/if_bridge.c
+++ b/sys/net/bridge/if_bridge.c
@@ -653,12 +653,12 @@ bridge_clone_create(struct if_clone *ifc, int unit)
 	bridge_rtable_init(sc);
 
 	callout_init(&sc->sc_brcallout);
-	netmsg_init(&sc->sc_brtimemsg, &netisr_adone_rport,
+	netmsg_init(&sc->sc_brtimemsg, NULL, &netisr_adone_rport,
 		    MSGF_DROPABLE, bridge_timer_handler);
 	sc->sc_brtimemsg.nm_lmsg.u.ms_resultp = sc;
 
 	callout_init(&sc->sc_bstpcallout);
-	netmsg_init(&sc->sc_bstptimemsg, &netisr_adone_rport,
+	netmsg_init(&sc->sc_bstptimemsg, NULL, &netisr_adone_rport,
 		    MSGF_DROPABLE, bstp_tick_handler);
 	sc->sc_bstptimemsg.nm_lmsg.u.ms_resultp = sc;
 
@@ -746,7 +746,8 @@ bridge_clone_destroy(struct ifnet *ifp)
 
 	ifnet_deserialize_all(ifp);
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, bridge_delete_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_delete_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_resultp = sc;
 	lwkt_domsg(BRIDGE_CFGPORT, lmsg, 0);
@@ -1782,7 +1783,8 @@ bridge_ifdetach(void *arg __unused, struct ifnet *ifp)
 	struct lwkt_msg *lmsg;
 	struct netmsg nmsg;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, bridge_ifdetach_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_ifdetach_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_resultp = ifp;
 
@@ -1823,8 +1825,8 @@ bridge_enqueue(struct ifnet *dst_ifp, struct mbuf *m)
 	struct netmsg_packet *nmp;
 
 	nmp = &m->m_hdr.mh_netmsg;
-	netmsg_init(&nmp->nm_netmsg, &netisr_apanic_rport, 0,
-		    bridge_enqueue_handler);
+	netmsg_init(&nmp->nm_netmsg, NULL, &netisr_apanic_rport,
+		    0, bridge_enqueue_handler);
 	nmp->nm_packet = m;
 	nmp->nm_netmsg.nm_lmsg.u.ms_resultp = dst_ifp;
 
@@ -2516,8 +2518,8 @@ bridge_rtmsg_sync(struct bridge_softc *sc)
 
 	ASSERT_IFNET_NOT_SERIALIZED_ALL(sc->sc_ifp);
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0,
-		    bridge_rtmsg_sync_handler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_rtmsg_sync_handler);
 	ifnet_domsg(&nmsg.nm_lmsg, 0);
 }
 
@@ -2640,8 +2642,8 @@ bridge_rtupdate(struct bridge_softc *sc, const uint8_t *dst,
 		if (brmsg == NULL)
 			return ENOMEM;
 
-		netmsg_init(&brmsg->br_nmsg, &netisr_afree_rport, 0,
-			    bridge_rtinstall_handler);
+		netmsg_init(&brmsg->br_nmsg, NULL, &netisr_afree_rport,
+			    0, bridge_rtinstall_handler);
 		memcpy(brmsg->br_dst, dst, ETHER_ADDR_LEN);
 		brmsg->br_dst_if = dst_if;
 		brmsg->br_flags = flags;
@@ -2665,8 +2667,8 @@ bridge_rtsaddr(struct bridge_softc *sc, const uint8_t *dst,
 
 	ASSERT_IFNET_NOT_SERIALIZED_ALL(sc->sc_ifp);
 
-	netmsg_init(&brmsg.br_nmsg, &curthread->td_msgport, 0,
-		    bridge_rtinstall_handler);
+	netmsg_init(&brmsg.br_nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_rtinstall_handler);
 	memcpy(brmsg.br_dst, dst, ETHER_ADDR_LEN);
 	brmsg.br_dst_if = dst_if;
 	brmsg.br_flags = flags;
@@ -2712,7 +2714,8 @@ bridge_rtreap(struct bridge_softc *sc)
 
 	ASSERT_IFNET_NOT_SERIALIZED_ALL(sc->sc_ifp);
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, bridge_rtreap_handler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_rtreap_handler);
 	nmsg.nm_lmsg.u.ms_resultp = sc;
 
 	ifnet_domsg(&nmsg.nm_lmsg, 0);
@@ -2725,7 +2728,8 @@ bridge_rtreap_async(struct bridge_softc *sc)
 
 	nmsg = kmalloc(sizeof(*nmsg), M_LWKTMSG, M_WAITOK);
 
-	netmsg_init(nmsg, &netisr_afree_rport, 0, bridge_rtreap_handler);
+	netmsg_init(nmsg, NULL, &netisr_afree_rport,
+		    0, bridge_rtreap_handler);
 	nmsg->nm_lmsg.u.ms_resultp = sc;
 
 	ifnet_sendmsg(&nmsg->nm_lmsg, 0);
@@ -3692,7 +3696,8 @@ bridge_control(struct bridge_softc *sc, u_long cmd,
 	bzero(&bc_msg, sizeof(bc_msg));
 	nmsg = &bc_msg.bc_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, bridge_control_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_control_dispatch);
 	bc_msg.bc_func = bc_func;
 	bc_msg.bc_sc = sc;
 	bc_msg.bc_arg = bc_arg;
@@ -3731,8 +3736,8 @@ bridge_add_bif(struct bridge_softc *sc, struct bridge_ifinfo *bif_info,
 
 	ASSERT_IFNET_NOT_SERIALIZED_ALL(sc->sc_ifp);
 
-	netmsg_init(&amsg.br_nmsg, &curthread->td_msgport, 0,
-		    bridge_add_bif_handler);
+	netmsg_init(&amsg.br_nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_add_bif_handler);
 	amsg.br_softc = sc;
 	amsg.br_bif_info = bif_info;
 	amsg.br_bif_ifp = ifp;
@@ -3774,8 +3779,8 @@ bridge_del_bif(struct bridge_softc *sc, struct bridge_ifinfo *bif_info,
 
 	ASSERT_IFNET_NOT_SERIALIZED_ALL(sc->sc_ifp);
 
-	netmsg_init(&dmsg.br_nmsg, &curthread->td_msgport, 0,
-		    bridge_del_bif_handler);
+	netmsg_init(&dmsg.br_nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_del_bif_handler);
 	dmsg.br_softc = sc;
 	dmsg.br_bif_info = bif_info;
 	dmsg.br_bif_list = saved_bifs;
@@ -3812,8 +3817,8 @@ bridge_set_bifflags(struct bridge_softc *sc, struct bridge_ifinfo *bif_info,
 
 	ASSERT_IFNET_NOT_SERIALIZED_ALL(sc->sc_ifp);
 
-	netmsg_init(&smsg.br_nmsg, &curthread->td_msgport, 0,
-		    bridge_set_bifflags_handler);
+	netmsg_init(&smsg.br_nmsg, NULL, &curthread->td_msgport,
+		    0, bridge_set_bifflags_handler);
 	smsg.br_softc = sc;
 	smsg.br_bif_info = bif_info;
 	smsg.br_bif_flags = bif_flags;
diff --git a/sys/net/dummynet/ip_dummynet.c b/sys/net/dummynet/ip_dummynet.c
index 9e80e76..86df63d 100644
--- a/sys/net/dummynet/ip_dummynet.c
+++ b/sys/net/dummynet/ip_dummynet.c
@@ -1939,7 +1939,8 @@ ip_dn_init_dispatch(struct netmsg *msg)
     ip_dn_ctl_ptr = dummynet_ctl;
     ip_dn_io_ptr = dummynet_io;
 
-    netmsg_init(&dn_netmsg, &netisr_adone_rport, 0, dummynet);
+    netmsg_init(&dn_netmsg, NULL, &netisr_adone_rport,
+		0, dummynet);
     systimer_init_periodic_nq(&dn_clock, dummynet_clock, NULL, dn_hz);
 
 back:
@@ -1958,7 +1959,8 @@ ip_dn_init(void)
 	ip_dn_cpu = 0;
     }
 
-    netmsg_init(&smsg, &curthread->td_msgport, 0, ip_dn_init_dispatch);
+    netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		0, ip_dn_init_dispatch);
     lwkt_domsg(cpu_portfn(ip_dn_cpu), &smsg.nm_lmsg, 0);
     return smsg.nm_lmsg.ms_error;
 }
@@ -1987,7 +1989,8 @@ ip_dn_stop(void)
 {
     struct netmsg smsg;
 
-    netmsg_init(&smsg, &curthread->td_msgport, 0, ip_dn_stop_dispatch);
+    netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		0, ip_dn_stop_dispatch);
     lwkt_domsg(cpu_portfn(ip_dn_cpu), &smsg.nm_lmsg, 0);
 
     netmsg_service_sync();
diff --git a/sys/net/dummynet/ip_dummynet_glue.c b/sys/net/dummynet/ip_dummynet_glue.c
index a2cdd6a..214ae09 100644
--- a/sys/net/dummynet/ip_dummynet_glue.c
+++ b/sys/net/dummynet/ip_dummynet_glue.c
@@ -90,8 +90,8 @@ ip_dn_queue(struct mbuf *m)
 		("mbuf is not tagged for dummynet!\n"));
 
 	nmp = &m->m_hdr.mh_netmsg;
-	netmsg_init(&nmp->nm_netmsg, &netisr_apanic_rport, 0,
-		    ip_dn_dispatch);
+	netmsg_init(&nmp->nm_netmsg, NULL, &netisr_apanic_rport,
+		    0, ip_dn_dispatch);
 	nmp->nm_packet = m;
 
 	port = cpu_portfn(ip_dn_cpu);
@@ -109,8 +109,8 @@ ip_dn_packet_free(struct dn_pkt *pkt)
 		("mbuf is not tagged for dummynet!\n"));
 
 	nmp = &m->m_hdr.mh_netmsg;
-	netmsg_init(&nmp->nm_netmsg, &netisr_apanic_rport, 0,
-		    ip_dn_freepkt_dispatch);
+	netmsg_init(&nmp->nm_netmsg, NULL, &netisr_apanic_rport,
+		    0, ip_dn_freepkt_dispatch);
 	nmp->nm_packet = m;
 
 	lwkt_sendmsg(pkt->msgport, &nmp->nm_netmsg.nm_lmsg);
@@ -145,7 +145,8 @@ ip_dn_packet_redispatch(struct dn_pkt *pkt)
 		("mbuf is not tagged for dummynet!\n"));
 
 	nmp = &m->m_hdr.mh_netmsg;
-	netmsg_init(&nmp->nm_netmsg, &netisr_apanic_rport, 0, dispatch);
+	netmsg_init(&nmp->nm_netmsg, NULL, &netisr_apanic_rport,
+		    0, dispatch);
 	nmp->nm_packet = m;
 
 	lwkt_sendmsg(pkt->msgport, &nmp->nm_netmsg.nm_lmsg);
@@ -468,7 +469,8 @@ ip_dn_sockopt_flush(struct sockopt *sopt)
 	bzero(&dn_sopt, sizeof(dn_sopt));
 	dn_sopt.dn_sopt_name = sopt->sopt_name;
 
-	netmsg_init(&smsg, &curthread->td_msgport, 0, ip_dn_sockopt_dispatch);
+	netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		    0, ip_dn_sockopt_dispatch);
 	smsg.nm_lmsg.u.ms_resultp = &dn_sopt;
 	lwkt_domsg(cpu_portfn(ip_dn_cpu), &smsg.nm_lmsg, 0);
 
@@ -485,7 +487,8 @@ ip_dn_sockopt_get(struct sockopt *sopt)
 	bzero(&dn_sopt, sizeof(dn_sopt));
 	dn_sopt.dn_sopt_name = sopt->sopt_name;
 
-	netmsg_init(&smsg, &curthread->td_msgport, 0, ip_dn_sockopt_dispatch);
+	netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		    0, ip_dn_sockopt_dispatch);
 	smsg.nm_lmsg.u.ms_resultp = &dn_sopt;
 	lwkt_domsg(cpu_portfn(ip_dn_cpu), &smsg.nm_lmsg, 0);
 
@@ -519,7 +522,8 @@ ip_dn_sockopt_config(struct sockopt *sopt)
 	dn_sopt.dn_sopt_arg = &tmp_ioc_pipe;
 	dn_sopt.dn_sopt_arglen = sizeof(tmp_ioc_pipe);
 
-	netmsg_init(&smsg, &curthread->td_msgport, 0, ip_dn_sockopt_dispatch);
+	netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		    0, ip_dn_sockopt_dispatch);
 	smsg.nm_lmsg.u.ms_resultp = &dn_sopt;
 	lwkt_domsg(cpu_portfn(ip_dn_cpu), &smsg.nm_lmsg, 0);
 
diff --git a/sys/net/if.c b/sys/net/if.c
index 34c8ab7..fbda1cc 100644
--- a/sys/net/if.c
+++ b/sys/net/if.c
@@ -514,8 +514,8 @@ if_attach(struct ifnet *ifp, lwkt_serialize_t serializer)
 	ifp->if_start_nmsg = kmalloc(ncpus * sizeof(struct netmsg),
 				     M_LWKTMSG, M_WAITOK);
 	for (i = 0; i < ncpus; ++i) {
-		netmsg_init(&ifp->if_start_nmsg[i], &netisr_adone_rport, 0,
-			    if_start_dispatch);
+		netmsg_init(&ifp->if_start_nmsg[i], NULL, &netisr_adone_rport,
+			    0, if_start_dispatch);
 		ifp->if_start_nmsg[i].nm_lmsg.u.ms_resultp = ifp;
 	}
 
@@ -2324,8 +2324,8 @@ ifa_iflink(struct ifaddr *ifa, struct ifnet *ifp, int tail)
 {
 	struct netmsg_ifaddr msg;
 
-	netmsg_init(&msg.netmsg, &curthread->td_msgport, 0,
-		    ifa_iflink_dispatch);
+	netmsg_init(&msg.netmsg, NULL, &curthread->td_msgport,
+		    0, ifa_iflink_dispatch);
 	msg.ifa = ifa;
 	msg.ifp = ifp;
 	msg.tail = tail;
@@ -2362,8 +2362,8 @@ ifa_ifunlink(struct ifaddr *ifa, struct ifnet *ifp)
 {
 	struct netmsg_ifaddr msg;
 
-	netmsg_init(&msg.netmsg, &curthread->td_msgport, 0,
-		    ifa_ifunlink_dispatch);
+	netmsg_init(&msg.netmsg, NULL, &curthread->td_msgport,
+		    0, ifa_ifunlink_dispatch);
 	msg.ifa = ifa;
 	msg.ifp = ifp;
 
@@ -2384,8 +2384,8 @@ ifa_destroy(struct ifaddr *ifa)
 {
 	struct netmsg_ifaddr msg;
 
-	netmsg_init(&msg.netmsg, &curthread->td_msgport, 0,
-		    ifa_destroy_dispatch);
+	netmsg_init(&msg.netmsg, NULL, &curthread->td_msgport,
+		    0, ifa_destroy_dispatch);
 	msg.ifa = ifa;
 
 	ifa_domsg(&msg.netmsg.nm_lmsg, 0);
diff --git a/sys/net/if_ethersubr.c b/sys/net/if_ethersubr.c
index e06242f..c26e452 100644
--- a/sys/net/if_ethersubr.c
+++ b/sys/net/if_ethersubr.c
@@ -1536,8 +1536,8 @@ ether_init_netpacket(int num, struct mbuf *m)
 	struct netmsg_packet *pmsg;
 
 	pmsg = &m->m_hdr.mh_netmsg;
-	netmsg_init(&pmsg->nm_netmsg, &netisr_apanic_rport, MSGF_MPSAFE,
-		    ether_input_handler);
+	netmsg_init(&pmsg->nm_netmsg, NULL, &netisr_apanic_rport,
+		    MSGF_MPSAFE, ether_input_handler);
 	pmsg->nm_packet = m;
 	pmsg->nm_netmsg.nm_lmsg.u.ms_result = num;
 }
diff --git a/sys/net/if_poll.c b/sys/net/if_poll.c
index e56689d..817ee75 100644
--- a/sys/net/if_poll.c
+++ b/sys/net/if_poll.c
@@ -374,8 +374,8 @@ ifpoll_register(struct ifnet *ifp)
 
 	ifnet_deserialize_all(ifp);
 
-	netmsg_init(&nmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    ifpoll_register_handler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, ifpoll_register_handler);
 	nmsg.nm_lmsg.u.ms_resultp = &info;
 
 	error = ifnet_domsg(&nmsg.nm_lmsg, 0);
@@ -407,8 +407,8 @@ ifpoll_deregister(struct ifnet *ifp)
 
 	ifnet_deserialize_all(ifp);
 
-	netmsg_init(&nmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    ifpoll_deregister_handler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, ifpoll_deregister_handler);
 	nmsg.nm_lmsg.u.ms_resultp = ifp;
 
 	error = ifnet_domsg(&nmsg.nm_lmsg, 0);
@@ -503,8 +503,8 @@ stpoll_init(void)
 			&st_ctx->poll_handlers, 0,
 			"Number of registered status poll handlers");
 
-	netmsg_init(&st_ctx->poll_netmsg, &netisr_adone_rport, MSGF_MPSAFE,
-		    stpoll_handler);
+	netmsg_init(&st_ctx->poll_netmsg, NULL, &netisr_adone_rport,
+		    MSGF_MPSAFE, stpoll_handler);
 }
 
 /*
@@ -690,12 +690,12 @@ iopoll_ctx_create(int cpuid, int poll_type)
 	io_ctx->poll_cpuid = cpuid;
 	iopoll_reset_state(io_ctx);
 
-	netmsg_init(&io_ctx->poll_netmsg, &netisr_adone_rport, MSGF_MPSAFE,
-		    iopoll_handler);
+	netmsg_init(&io_ctx->poll_netmsg, NULL, &netisr_adone_rport,
+		    MSGF_MPSAFE, iopoll_handler);
 	io_ctx->poll_netmsg.nm_lmsg.u.ms_resultp = io_ctx;
 
-	netmsg_init(&io_ctx->poll_more_netmsg, &netisr_adone_rport, MSGF_MPSAFE,
-		    iopollmore_handler);
+	netmsg_init(&io_ctx->poll_more_netmsg, NULL, &netisr_adone_rport,
+		    MSGF_MPSAFE, iopollmore_handler);
 	io_ctx->poll_more_netmsg.nm_lmsg.u.ms_resultp = io_ctx;
 
 	/*
@@ -1005,8 +1005,8 @@ sysctl_burstmax(SYSCTL_HANDLER_ARGS)
 		burst_max = MAX_IOPOLL_BURST_MAX;
 
 	nmsg = &msg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    sysctl_burstmax_handler);
+	netmsg_init(nmsg, &curthread->td_msgport, NULL,
+		    MSGF_MPSAFE, sysctl_burstmax_handler);
 	nmsg->nm_lmsg.u.ms_result = burst_max;
 	msg.ctx = io_ctx;
 
@@ -1048,8 +1048,8 @@ sysctl_eachburst(SYSCTL_HANDLER_ARGS)
 		return error;
 
 	nmsg = &msg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    sysctl_eachburst_handler);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, sysctl_eachburst_handler);
 	nmsg->nm_lmsg.u.ms_result = each_burst;
 	msg.ctx = io_ctx;
 
@@ -1269,8 +1269,8 @@ sysctl_pollhz(SYSCTL_HANDLER_ARGS)
 	else if (phz > IFPOLL_FREQ_MAX)
 		phz = IFPOLL_FREQ_MAX;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    sysctl_pollhz_handler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, sysctl_pollhz_handler);
 	nmsg.nm_lmsg.u.ms_result = phz;
 
 	return ifnet_domsg(&nmsg.nm_lmsg, comm->poll_cpuid);
@@ -1319,8 +1319,8 @@ sysctl_stfrac(SYSCTL_HANDLER_ARGS)
 	if (stfrac < 0)
 		return EINVAL;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    sysctl_stfrac_handler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, sysctl_stfrac_handler);
 	nmsg.nm_lmsg.u.ms_result = stfrac;
 
 	return ifnet_domsg(&nmsg.nm_lmsg, comm->poll_cpuid);
@@ -1357,8 +1357,8 @@ sysctl_txfrac(SYSCTL_HANDLER_ARGS)
 	if (txfrac < 0)
 		return EINVAL;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, MSGF_MPSAFE,
-		    sysctl_txfrac_handler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    MSGF_MPSAFE, sysctl_txfrac_handler);
 	nmsg.nm_lmsg.u.ms_result = txfrac;
 
 	return ifnet_domsg(&nmsg.nm_lmsg, comm->poll_cpuid);
diff --git a/sys/net/ipfw/ip_fw2.c b/sys/net/ipfw/ip_fw2.c
index b2816c7..6210748 100644
--- a/sys/net/ipfw/ip_fw2.c
+++ b/sys/net/ipfw/ip_fw2.c
@@ -2728,7 +2728,8 @@ ipfw_add_rule(struct ipfw_ioc_rule *ioc_rule, uint32_t rule_flags)
 	 */
 	bzero(&fwmsg, sizeof(fwmsg));
 	nmsg = &fwmsg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0, ipfw_add_rule_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_add_rule_dispatch);
 	fwmsg.ioc_rule = ioc_rule;
 	fwmsg.prev_rule = prev;
 	fwmsg.next_rule = prev == NULL ? NULL : f;
@@ -2746,8 +2747,8 @@ ipfw_add_rule(struct ipfw_ioc_rule *ioc_rule, uint32_t rule_flags)
 		 * CPUs have been setup.
 		 */
 		bzero(nmsg, sizeof(*nmsg));
-		netmsg_init(nmsg, &curthread->td_msgport, 0,
-			    ipfw_enable_state_dispatch);
+		netmsg_init(nmsg, NULL, &curthread->td_msgport,
+			    0, ipfw_enable_state_dispatch);
 		nmsg->nm_lmsg.u.ms_resultp = rule;
 
 		ifnet_domsg(&nmsg->nm_lmsg, 0);
@@ -2896,8 +2897,8 @@ ipfw_flush(int kill_default)
 	 * will be created.
 	 */
 	bzero(&dmsg, sizeof(dmsg));
-	netmsg_init(&dmsg.nmsg, &curthread->td_msgport, 0,
-		    ipfw_disable_rule_state_dispatch);
+	netmsg_init(&dmsg.nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_disable_rule_state_dispatch);
 	ifnet_domsg(&dmsg.nmsg.nm_lmsg, 0);
 
 	/*
@@ -2921,7 +2922,8 @@ ipfw_flush(int kill_default)
 	 * Press the 'flush' button
 	 */
 	bzero(&nmsg, sizeof(nmsg));
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, ipfw_flush_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_flush_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_result = kill_default;
 	ifnet_domsg(lmsg, 0);
@@ -3025,8 +3027,8 @@ ipfw_alt_delete_rule(uint16_t rulenum)
 		 */
 		bzero(&dmsg, sizeof(dmsg));
 		nmsg = &dmsg.nmsg;
-		netmsg_init(nmsg, &curthread->td_msgport, 0,
-			    ipfw_disable_rule_state_dispatch);
+		netmsg_init(nmsg, NULL, &curthread->td_msgport,
+			    0, ipfw_disable_rule_state_dispatch);
 		dmsg.start_rule = rule;
 		dmsg.rulenum = rulenum;
 
@@ -3056,8 +3058,8 @@ ipfw_alt_delete_rule(uint16_t rulenum)
 	 */
 	bzero(&dmsg, sizeof(dmsg));
 	nmsg = &dmsg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0,
-		    ipfw_alt_delete_rule_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_alt_delete_rule_dispatch);
 	dmsg.prev_rule = prev;
 	dmsg.start_rule = rule;
 	dmsg.rulenum = rulenum;
@@ -3157,8 +3159,8 @@ ipfw_alt_delete_ruleset(uint8_t set)
 		 */
 		bzero(&dmsg, sizeof(dmsg));
 		nmsg = &dmsg.nmsg;
-		netmsg_init(nmsg, &curthread->td_msgport, 0,
-			    ipfw_disable_ruleset_state_dispatch);
+		netmsg_init(nmsg, NULL, &curthread->td_msgport,
+			    0, ipfw_disable_ruleset_state_dispatch);
 		dmsg.from_set = set;
 
 		ifnet_domsg(&nmsg->nm_lmsg, 0);
@@ -3189,8 +3191,8 @@ ipfw_alt_delete_ruleset(uint8_t set)
 	 */
 	bzero(&dmsg, sizeof(dmsg));
 	nmsg = &dmsg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0,
-		    ipfw_alt_delete_ruleset_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_alt_delete_ruleset_dispatch);
 	dmsg.from_set = set;
 
 	ifnet_domsg(&nmsg->nm_lmsg, 0);
@@ -3241,8 +3243,8 @@ ipfw_alt_move_rule(uint16_t rulenum, uint8_t set)
 
 	bzero(&dmsg, sizeof(dmsg));
 	nmsg = &dmsg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0,
-		    ipfw_alt_move_rule_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_alt_move_rule_dispatch);
 	dmsg.start_rule = rule;
 	dmsg.rulenum = rulenum;
 	dmsg.to_set = set;
@@ -3274,8 +3276,8 @@ ipfw_alt_move_ruleset(uint8_t from_set, uint8_t to_set)
 
 	bzero(&dmsg, sizeof(dmsg));
 	nmsg = &dmsg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0,
-		    ipfw_alt_move_ruleset_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_alt_move_ruleset_dispatch);
 	dmsg.from_set = from_set;
 	dmsg.to_set = to_set;
 
@@ -3307,8 +3309,8 @@ ipfw_alt_swap_ruleset(uint8_t set1, uint8_t set2)
 
 	bzero(&dmsg, sizeof(dmsg));
 	nmsg = &dmsg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0,
-		    ipfw_alt_swap_ruleset_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_alt_swap_ruleset_dispatch);
 	dmsg.from_set = set1;
 	dmsg.to_set = set2;
 
@@ -3443,7 +3445,8 @@ ipfw_ctl_zero_entry(int rulenum, int log_only)
 
 	bzero(&zmsg, sizeof(zmsg));
 	nmsg = &zmsg.nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0, ipfw_zero_entry_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_zero_entry_dispatch);
 	zmsg.log_only = log_only;
 
 	if (rulenum == 0) {
@@ -3890,7 +3893,8 @@ ipfw_ctl_set_disable(uint32_t disable, uint32_t enable)
 	set_disable = (ipfw_ctx[mycpuid]->ipfw_set_disable | disable) & ~enable;
 
 	bzero(&nmsg, sizeof(nmsg));
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, ipfw_set_disable_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_set_disable_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_result32 = set_disable;
 
@@ -4293,8 +4297,8 @@ ipfw_sysctl_enable(SYSCTL_HANDLER_ARGS)
 	if (error || req->newptr == NULL)
 		return error;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0,
-		    ipfw_sysctl_enable_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_sysctl_enable_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_result = enable;
 
@@ -4405,8 +4409,8 @@ ipfw_init_dispatch(struct netmsg *nmsg)
 	}
 
 	bzero(&fwmsg, sizeof(fwmsg));
-	netmsg_init(&fwmsg.nmsg, &curthread->td_msgport, 0,
-		    ipfw_ctx_init_dispatch);
+	netmsg_init(&fwmsg.nmsg, NULL, &curthread->td_msgport,
+		    0, ipfw_ctx_init_dispatch);
 	ifnet_domsg(&fwmsg.nmsg.nm_lmsg, 0);
 
 	ip_fw_chk_ptr = ipfw_chk;
@@ -4433,7 +4437,7 @@ ipfw_init_dispatch(struct netmsg *nmsg)
 	}
 
 	callout_init_mp(&ipfw_timeout_h);
-	netmsg_init(&ipfw_timeout_netmsg, &netisr_adone_rport,
+	netmsg_init(&ipfw_timeout_netmsg, NULL, &netisr_adone_rport,
 		    MSGF_MPSAFE | MSGF_DROPABLE | MSGF_PRIORITY,
 		    ipfw_tick_dispatch);
 	lockinit(&dyn_lock, "ipfw_dyn", 0, 0);
@@ -4452,7 +4456,8 @@ ipfw_init(void)
 {
 	struct netmsg smsg;
 
-	netmsg_init(&smsg, &curthread->td_msgport, 0, ipfw_init_dispatch);
+	netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		    0, ipfw_init_dispatch);
 	return lwkt_domsg(IPFW_CFGPORT, &smsg.nm_lmsg, 0);
 }
 
@@ -4503,7 +4508,8 @@ ipfw_fini(void)
 {
 	struct netmsg smsg;
 
-	netmsg_init(&smsg, &curthread->td_msgport, 0, ipfw_fini_dispatch);
+	netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		    0, ipfw_fini_dispatch);
 	return lwkt_domsg(IPFW_CFGPORT, &smsg.nm_lmsg, 0);
 }
 
diff --git a/sys/net/ipfw/ip_fw2_glue.c b/sys/net/ipfw/ip_fw2_glue.c
index ca7d88f..3a1c947 100644
--- a/sys/net/ipfw/ip_fw2_glue.c
+++ b/sys/net/ipfw/ip_fw2_glue.c
@@ -68,7 +68,8 @@ ip_fw_sockopt(struct sockopt *sopt)
 			return EPERM;
 	}
 
-	netmsg_init(&smsg, &curthread->td_msgport, 0, ip_fw_sockopt_dispatch);
+	netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		    0, ip_fw_sockopt_dispatch);
 	smsg.nm_lmsg.u.ms_resultp = sopt;
 	return lwkt_domsg(IPFW_CFGPORT, &smsg.nm_lmsg, 0);
 }
diff --git a/sys/net/netisr.c b/sys/net/netisr.c
index c35c371..2a3d620 100644
--- a/sys/net/netisr.c
+++ b/sys/net/netisr.c
@@ -47,6 +47,7 @@
 #include <sys/interrupt.h>
 #include <sys/socket.h>
 #include <sys/sysctl.h>
+#include <sys/socketvar.h>
 #include <net/if.h>
 #include <net/if_var.h>
 #include <net/netisr.h>
@@ -243,7 +244,8 @@ netmsg_service_sync(void)
     struct netmsg_port_registration *reg;
     struct netmsg smsg;
 
-    netmsg_init(&smsg, &curthread->td_msgport, MSGF_MPSAFE, netmsg_sync_func);
+    netmsg_init(&smsg, NULL, &curthread->td_msgport,
+		MSGF_MPSAFE, netmsg_sync_func);
 
     TAILQ_FOREACH(reg, &netreglist, npr_entry) {
 	lwkt_domsg(reg->npr_port, &smsg.nm_lmsg, 0);
@@ -261,12 +263,33 @@ netmsg_sync_func(struct netmsg *msg)
 }
 
 /*
- * Return current BGL lock state (1:locked, 0: unlocked)
+ * Service a netmsg request and modify the BGL lock state if appropriate.
+ * The new BGL lock state is returned (1:locked, 0:unlocked).
  */
 int
 netmsg_service(struct netmsg *msg, int mpsafe_mode, int mplocked)
 {
     /*
+     * If nm_so is non-NULL the message is related to a socket.  Sockets
+     * can migrate between protocol processing threads when they connect,
+     * due to an implied connect during a sendmsg(), or when a connection
+     * is accepted.
+     *
+     * If this occurs any messages already queued to the original thread
+     * or which race the change must be forwarded to the new protocol
+     * processing port.
+     *
+     * MPSAFE - socket changes are synchronous to the current protocol port
+     * 		so if the port can only change out from under us if it is
+     *		already different from the current port anyway so we forward
+     *		it.  It is possible to chase a changing port, which is fine.
+     */
+    if (msg->nm_so && msg->nm_so->so_port != &curthread->td_msgport) {
+	lwkt_forwardmsg(msg->nm_so->so_port, &msg->nm_lmsg);
+	return(mplocked);
+    }
+
+    /*
      * Adjust the mplock dynamically.
      */
     switch (mpsafe_mode) {
@@ -372,8 +395,8 @@ netisr_queue(int num, struct mbuf *m)
 
     pmsg = &m->m_hdr.mh_netmsg;
 
-    netmsg_init(&pmsg->nm_netmsg, &netisr_apanic_rport, NETISR_TO_MSGF(ni),
-    		ni->ni_handler);
+    netmsg_init(&pmsg->nm_netmsg, NULL, &netisr_apanic_rport,
+		NETISR_TO_MSGF(ni), ni->ni_handler);
     pmsg->nm_packet = m;
     pmsg->nm_netmsg.nm_lmsg.u.ms_result = num;
     lwkt_sendmsg(port, &pmsg->nm_netmsg.nm_lmsg);
@@ -395,7 +418,8 @@ netisr_register(int num, pkt_portfn_t mportfn,
     ni->ni_mport_pktinfo = mportfn_pktinfo;
     ni->ni_handler = handler;
     ni->ni_flags = flags;
-    netmsg_init(&ni->ni_netmsg, &netisr_adone_rport, NETISR_TO_MSGF(ni), NULL);
+    netmsg_init(&ni->ni_netmsg, NULL, &netisr_adone_rport,
+		NETISR_TO_MSGF(ni), NULL);
 }
 
 int
@@ -445,7 +469,7 @@ cur_netport(void)
 /* ARGSUSED */
 lwkt_port_t
 cpu0_soport(struct socket *so __unused, struct sockaddr *nam __unused,
-	    struct mbuf **dummy __unused, int req __unused)
+	    struct mbuf **dummy __unused)
 {
     return (&netisr_cpu[0].td_msgport);
 }
@@ -459,7 +483,7 @@ cpu0_ctlport(int cmd __unused, struct sockaddr *sa __unused,
 
 lwkt_port_t
 sync_soport(struct socket *so __unused, struct sockaddr *nam __unused,
-	    struct mbuf **dummy __unused, int req __unused)
+	    struct mbuf **dummy __unused)
 {
     return (&netisr_sync_port);
 }
@@ -487,8 +511,8 @@ schednetisr_remote(void *data)
     pmsg = &netisrs[num].ni_netmsg;
     crit_enter();
     if (pmsg->nm_lmsg.ms_flags & MSGF_DONE) {
-	netmsg_init(pmsg, &netisr_adone_rport, NETISR_TO_MSGF(ni),
-		    ni->ni_handler);
+	netmsg_init(pmsg, NULL, &netisr_adone_rport,
+		    NETISR_TO_MSGF(ni), ni->ni_handler);
 	pmsg->nm_lmsg.u.ms_result = num;
 	lwkt_sendmsg(port, &pmsg->nm_lmsg);
     }
@@ -556,7 +580,8 @@ netisr_run(int num, struct mbuf *m)
 
     pmsg = &m->m_hdr.mh_netmsg;
 
-    netmsg_init(&pmsg->nm_netmsg, &netisr_apanic_rport, 0, ni->ni_handler);
+    netmsg_init(&pmsg->nm_netmsg, NULL, &netisr_apanic_rport,
+		0, ni->ni_handler);
     pmsg->nm_packet = m;
     pmsg->nm_netmsg.nm_lmsg.u.ms_result = num;
 
diff --git a/sys/net/netmsg.h b/sys/net/netmsg.h
index 5b5d497..da0c5c2 100644
--- a/sys/net/netmsg.h
+++ b/sys/net/netmsg.h
@@ -50,6 +50,7 @@ typedef void (*netisr_fn_t)(struct netmsg *);
 typedef struct netmsg {
     struct lwkt_msg     nm_lmsg;
     netisr_fn_t		nm_dispatch;
+    struct socket	*nm_so;
 } *netmsg_t;
 
 #define MSGF_MPSAFE	MSGF_USER0
@@ -62,20 +63,17 @@ typedef struct netmsg {
 struct netmsg_pru_abort {
     struct netmsg	nm_netmsg;
     pru_abort_fn_t	nm_prufn;
-    struct socket	*nm_so;
 };
 
 struct netmsg_pru_accept {
     struct netmsg	nm_netmsg;
     pru_accept_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct sockaddr	**nm_nam;
 };
 
 struct netmsg_pru_attach {
     struct netmsg	nm_netmsg;
     pru_attach_fn_t	nm_prufn;
-    struct socket	*nm_so;
     int			nm_proto;
     struct pru_attach_info *nm_ai;
 };
@@ -83,7 +81,6 @@ struct netmsg_pru_attach {
 struct netmsg_pru_bind {
     struct netmsg	nm_netmsg;
     pru_bind_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct sockaddr	*nm_nam;
     struct thread	*nm_td;
 };
@@ -91,7 +88,6 @@ struct netmsg_pru_bind {
 struct netmsg_pru_connect {
     struct netmsg	nm_netmsg;
     pru_connect_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct sockaddr	*nm_nam;
     struct thread	*nm_td;
 };
@@ -106,7 +102,6 @@ struct netmsg_pru_connect2 {
 struct netmsg_pru_control {
     struct netmsg	nm_netmsg;
     pru_control_fn_t	nm_prufn;
-    struct socket	*nm_so;
     u_long		nm_cmd;
     caddr_t		nm_data;
     struct ifnet	*nm_ifp;
@@ -116,40 +111,34 @@ struct netmsg_pru_control {
 struct netmsg_pru_detach {
     struct netmsg	nm_netmsg;
     pru_detach_fn_t	nm_prufn;
-    struct socket	*nm_so;
 };
 
 struct netmsg_pru_disconnect {
     struct netmsg	nm_netmsg;
     pru_disconnect_fn_t	nm_prufn;
-    struct socket	*nm_so;
 };
 
 struct netmsg_pru_listen {
     struct netmsg	nm_netmsg;
     pru_listen_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct thread	*nm_td;
 };
 
 struct netmsg_pru_peeraddr {
     struct netmsg	nm_netmsg;
     pru_peeraddr_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct sockaddr	**nm_nam;
 };
 
 struct netmsg_pru_rcvd {
     struct netmsg	nm_netmsg;
     pru_rcvd_fn_t	nm_prufn;
-    struct socket	*nm_so;
     int			nm_flags;
 };
 
 struct netmsg_pru_rcvoob {
     struct netmsg	nm_netmsg;
     pru_rcvoob_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct mbuf		*nm_m;
     int			nm_flags;
 };
@@ -157,7 +146,6 @@ struct netmsg_pru_rcvoob {
 struct netmsg_pru_send {
     struct netmsg	nm_netmsg;
     pru_send_fn_t	nm_prufn;
-    struct socket	*nm_so;
     int			nm_flags;
     struct mbuf		*nm_m;
     struct sockaddr	*nm_addr;
@@ -168,27 +156,23 @@ struct netmsg_pru_send {
 struct netmsg_pru_sense {
     struct netmsg	nm_netmsg;
     pru_sense_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct stat		*nm_stat;
 };
 
 struct netmsg_pru_shutdown {
     struct netmsg	nm_netmsg;
     pru_shutdown_fn_t	nm_prufn;
-    struct socket	*nm_so;
 };
 
 struct netmsg_pru_sockaddr {
     struct netmsg	nm_netmsg;
     pru_sockaddr_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct sockaddr	**nm_nam;
 };
 
 struct netmsg_pru_sosend {
     struct netmsg	nm_netmsg;
     pru_sosend_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct sockaddr	*nm_addr;
     struct uio		*nm_uio;
     struct mbuf		*nm_top;
@@ -200,7 +184,6 @@ struct netmsg_pru_sosend {
 struct netmsg_pru_soreceive {
     struct netmsg	nm_netmsg;
     struct sockaddr	*nm_addr;
-    struct socket	*nm_so;
     struct sockaddr	**nm_paddr;
     struct uio		*nm_uio;
     struct sockbuf	*nm_sio;
@@ -211,7 +194,6 @@ struct netmsg_pru_soreceive {
 struct netmsg_pru_sopoll {
     struct netmsg	nm_netmsg;
     pru_sopoll_fn_t	nm_prufn;
-    struct socket	*nm_so;
     int			nm_events;
     struct ucred	*nm_cred;
     struct thread	*nm_td;
@@ -220,7 +202,6 @@ struct netmsg_pru_sopoll {
 struct netmsg_pru_ctloutput {
     struct netmsg	nm_netmsg;
     pru_ctloutput_fn_t	nm_prufn;
-    struct socket	*nm_so;
     struct sockopt	*nm_sopt;
 };
 
diff --git a/sys/net/netmsg2.h b/sys/net/netmsg2.h
index 24b815e..b55e9bb 100644
--- a/sys/net/netmsg2.h
+++ b/sys/net/netmsg2.h
@@ -43,21 +43,25 @@
 
 /*
  * Extended lwkt_initmsg() for netmsg's, also initializing the
- * dispatch function
+ * dispatch function.
  */
 static __inline void
-netmsg_init(netmsg_t msg, lwkt_port_t rport, int flags, netisr_fn_t dispatch)
+netmsg_init(netmsg_t msg, struct socket *so, lwkt_port_t rport,
+	    int flags, netisr_fn_t dispatch)
 {
     lwkt_initmsg(&msg->nm_lmsg, rport, flags);
     msg->nm_dispatch = dispatch;
+    msg->nm_so = so;
 }
 
 static __inline void
-netmsg_init_abortable(netmsg_t msg, lwkt_port_t rport, int flags,
-		      netisr_fn_t dispatch, void (*abortfn)(lwkt_msg_t))
+netmsg_init_abortable(netmsg_t msg, struct socket *so, lwkt_port_t rport,
+		      int flags, netisr_fn_t dispatch,
+		      void (*abortfn)(lwkt_msg_t))
 {
     lwkt_initmsg_abortable(&msg->nm_lmsg, rport, flags, abortfn);
     msg->nm_dispatch = dispatch;
+    msg->nm_so = so;
 }
 
 #endif /* _NET_NETMSG2_H_ */
diff --git a/sys/net/pf/pf.c b/sys/net/pf/pf.c
index e09622b..4afc291 100644
--- a/sys/net/pf/pf.c
+++ b/sys/net/pf/pf.c
@@ -2241,8 +2241,8 @@ pf_socket_lookup(uid_t *uid, gid_t *gid, int direction, struct pf_pdesc *pd)
 		 */
 		if (pi_cpu != mycpu->gd_cpuid) {
 			msg = kmalloc(sizeof(*msg), M_LWKTMSG, M_INTWAIT);
-			netmsg_init(&msg->nm_netmsg, &netisr_afree_rport, 0,
-				    in_pcblookup_hash_handler);
+			netmsg_init(&msg->nm_netmsg, NULL, &netisr_afree_rport,
+				    0, in_pcblookup_hash_handler);
 			msg->nm_pinp = &inp;
 			msg->nm_pcbinfo = pi;
 			msg->nm_saddr = saddr;
